#ifndef FIRST_H
#define FIRST_H
/***************************************************************************
 *
 * INCLUDEFILE  : FIRST.H
 *
 * to MODULE    : FIRST.C
 *
 *
 * to PROJECT   : FIRST
 *
 ***************************************************************************
 *
 * Author       : RAV
 *
 *
 * Copyright by : (c) SPECTRO A. I. GmbH 2006
 *
 * Date         : 
 *
 * Version      : 1.00
 *
 ***************************************************************************
 * Name:      Vers.  Date:       History of Changes :
 *
 * RAV        1.00   20.11.2006  First implementation
 *
 ***************************************************************************/

#define  SYS_CLOCK              14745600L
#define  MAX_BAUDRATE           19200

#define  ON                     1
#define  OFF                    0
#define  OPEN                   1
#define  CLOSED                 0

/*********************************************************************************
 * IOs on Port A
 *********************************************************************************/

#define  SEL_IOX_0_OUTPUT       {PORTA |= 0x01; DDRA |= 0x01;}
#define  SEL_IOX_1_OUTPUT       {PORTA |= 0x02; DDRA |= 0x02;}
#define  SEL_IOX_2_OUTPUT       {PORTA |= 0x04; DDRA |= 0x04;}
#define  SEL_IOX_3_OUTPUT       {PORTA |= 0x08; DDRA |= 0x08;}
#define  SEL_IOX_4_OUTPUT       {PORTA |= 0x10; DDRA |= 0x10;}
#define  SEL_IOX_5_OUTPUT       {PORTA |= 0x20; DDRA |= 0x20;}
#define  SEL_IOX_6_OUTPUT       {PORTA |= 0x40; DDRA |= 0x40;}
#define  SEL_IOX_7_OUTPUT       {PORTA |= 0x80; DDRA |= 0x80;}

#define  SEL_IOX_0_INPUT        {PORTA |= 0x01; DDRA &= ~0x01;}
#define  SEL_IOX_1_INPUT        {PORTA |= 0x02; DDRA &= ~0x02;}
#define  SEL_IOX_2_INPUT        {PORTA |= 0x04; DDRA &= ~0x04;}
#define  SEL_IOX_3_INPUT        {PORTA |= 0x08; DDRA &= ~0x08;}
#define  SEL_IOX_4_INPUT        {PORTA |= 0x10; DDRA &= ~0x10;}
#define  SEL_IOX_5_INPUT        {PORTA |= 0x20; DDRA &= ~0x20;}
#define  SEL_IOX_6_INPUT        {PORTA |= 0x40; DDRA &= ~0x40;}
#define  SEL_IOX_7_INPUT        {PORTA |= 0x80; DDRA &= ~0x80;}

#define  SET_IOX_0              PORTA &= ~0x01;
#define  SET_IOX_1              PORTA &= ~0x02;
#define  SET_IOX_2              PORTA &= ~0x04;
#define  SET_IOX_3              PORTA &= ~0x08;
#define  SET_IOX_4              PORTA &= ~0x10;
#define  SET_IOX_5              PORTA &= ~0x20;
#define  SET_IOX_6              PORTA &= ~0x40;
#define  SET_IOX_7              PORTA &= ~0x80;

#define  RESET_IOX_0            PORTA |= 0x01;
#define  RESET_IOX_1            PORTA |= 0x02;
#define  RESET_IOX_2            PORTA |= 0x04;
#define  RESET_IOX_3            PORTA |= 0x08;
#define  RESET_IOX_4            PORTA |= 0x10;
#define  RESET_IOX_5            PORTA |= 0x20;
#define  RESET_IOX_6            PORTA |= 0x40;
#define  RESET_IOX_7            PORTA |= 0x80;

#define  IOX_0                  ((PINA & 0x01) == 0x00)
#define  IOX_1                  ((PINA & 0x02) == 0x00)
#define  IOX_2                  ((PINA & 0x04) == 0x00)
#define  IOX_3                  ((PINA & 0x08) == 0x00)
#define  IOX_4                  ((PINA & 0x10) == 0x00)
#define  IOX_5                  ((PINA & 0x20) == 0x00)
#define  IOX_6                  ((PINA & 0x40) == 0x00)
#define  IOX_7                  ((PINA & 0x80) == 0x00)

/*********************************************************************************
 * IOs on Port B
 *********************************************************************************/

#define  SET_DIG_OUT_0          PORTB &= ~0x01             /* ST19               */
#define  RESET_DIG_OUT_0        PORTB |= 0x01
#define  SET_DIG_OUT_1          PORTB &= ~0x02             /* ST20               */
#define  RESET_DIG_OUT_1        PORTB |= 0x02
#define  SET_DIG_OUT_2          PORTB &= ~0x04             /* ST17               */
#define  RESET_DIG_OUT_2        PORTB |= 0x04
#define  SET_DIG_OUT_3          PORTB &= ~0x08             /* ST18               */
#define  RESET_DIG_OUT_3        PORTB |= 0x08
#define  SET_DIG_OUT_4          PORTB &= ~0x10             /* ST9                */
#define  RESET_DIG_OUT_4        PORTB |= 0x10
#define  SET_DIG_OUT_5          PORTB &= ~0x20             /* ST10               */
#define  RESET_DIG_OUT_5        PORTB |= 0x20
#define  SET_PWM0               PORTB &= ~0x40             /* ST5                */
#define  RESET_PWM0             PORTB |= 0x40
#define  SET_PWM2               PORTB &= ~0x80             /* ST32.5             */
#define  RESET_PWM2             PORTB |= 0x80

/*********************************************************************************
 * IOs on Port C
 *********************************************************************************/

#define  DIG_IN_0               ((PINC & 0x01) == 0x00)    /* ST21               */
#define  DIG_IN_1               ((PINC & 0x02) == 0x00)    /* ST22               */
#define  DIG_IN_2               ((PINC & 0x04) == 0x00)    /* ST8                */
#define  DIG_IN_3               ((PINC & 0x08) == 0x00)    /* ST7                */
#define  DIG_IN_4               ((PINC & 0x10) == 0x00)    /* ST23               */
#define  DIG_IN_5               ((PINC & 0x20) == 0x00)    /* ST24               */
#define  DIG_IN_6               ((PINC & 0x40) == 0x00)    /* ST25               */
#define  DIG_IN_7               ((PINC & 0x80) == 0x00)    /* ST26               */

#define  VALVE_CTL_INPUTS       (~PINC & 0x0F)         

/*********************************************************************************
 * IOs on Port D
 *********************************************************************************/

#define  SET_LED                PORTD |= 0x20              /* DEBUG LED          */
#define  RESET_LED              PORTD &= ~0x20
#define  AUX_IN_0_TRUE          ((PIND & 0x40) != 0x00)    /* ST3.2              */
#define  AUX_IN_1_TRUE          ((PIND & 0x80) != 0x00)    /* ST4.2              */
//#define  AUX_INPUTS             ((P3 >> 4) & 0x03)
//#define  PX                     (~P3 >> 4)           /* AUX inputs for PLC                */

/*********************************************************************************
 * IOs on Port E
 *********************************************************************************/

#define  SET_PWM1               PORTE &= ~0x10             /* ST6                */
#define  RESET_PWM1             PORTE |= 0x10
#define  SET_PWM3               PORTE &= ~0x20             /* ST32.6             */
#define  RESET_PWM3             PORTE |= 0x20
#define  OPT_IN                 ((PINE & 0x40) == 0x00)
#define  OPT_INPUT              (~PINE & 0x40)

/*********************************************************************************
 * Mode defines
 *********************************************************************************/

#define IM_DFORM_BINARY         0
#define IM_DFORM_CELSIUS        1                    /* Standard KTY range       */
#define IM_DFORM_EXT_CELSIUS    2                    /* KTY || 8k2   range       */
#define IM_DFORM_MAX_EXP3       60

#define IM_ACT_VALUE            0x00
#define IM_AUX_VALUE            0x01
#define IM_SMP_VALUE            0x02





#endif

